//this is an absolute hack of Emmanuel Jourdan's waveformcirc


import com.cycling74.max.*;
import com.cycling74.msp.*;

public class waveformhack extends MaxObject {
	private static final String[] INLET_ASSIST = new String[]{ "Messages in" };
	private static final String[] OUTLET_ASSIST = new String[]{ "Messages to lcd"};

	private int[] size = new int[] { 128, 128 };
	private double zoom = 0.5;
	private int grain = 100;
	private double inc = 1;
	private String buf_name = null;
	private float[] sb = new float[0];
	private boolean drawingBG= false;
	private int[] FGCOLOR = new int[]{0,100,255};
	
	public waveformhack() {
		declareIO(1, 1);
		createInfoOutlet(false);
		
		declareAttribute("size");
		declareAttribute("zoom");
		declareAttribute("grain",  null, "setattrGrain");
		declareAttribute("buf_name", null, "setattrBufName");

		setInletAssist(INLET_ASSIST);
		setOutletAssist(OUTLET_ASSIST);
	}

	public void frgb(int r,int g,int b)
	{
		FGCOLOR[0] = r;
		FGCOLOR[1] = g;
		FGCOLOR[2] = b; 
		redraw();
	}


	public void bang() {
		calculateSamples();
		redraw();
	}
	
	private void setattrGrain(int grain) {
		if (grain > 0)
			this.grain = grain;
	}
	
	private void setattrBufName(String s) {
		if (s != null)
			this.buf_name = s;
	}
	
	private void calculateSamples() {
		if (buf_name == null)
			return;
		
		long frames = MSPBuffer.getFrames(buf_name);
		if (frames <= 0)
			return;
		
		this.sb = new float[this.grain];
		long blocks = this.grain;
		double inc = (double)frames / (double)blocks;
		
		for (int i = 0; i < Math.round(blocks); i++) {
			sb[i] = peak(MSPBuffer.peek(buf_name, 0, Math.round(i * inc), Math.round(inc)));
		}
	}
	
	private float peak(float[] f) {
		float max = 0f;

		if (f == null)
			return max;
		
		for (int i = 0; i < f.length; i++) {
			if (Math.abs(f[i]) > max)
				max = Math.abs(f[i]);
		}
		return max;
	}
	
	public void redraw() {
		double phase = 0;
		long yOffset = Math.round(this.size[1] * 0.5);
		long height = 0;
		Atom[] curr = new Atom[4];
		Atom[] prev  = new Atom[4];
		Atom[] outputUpper  = new Atom[5];
		Atom[] outputLower  = new Atom[5];

		if (buf_name == null || sb.length == 0)
			return;

		drawingBG = true;
		outlet(0, "local", 0);
		outlet(0, "enablesprites", 1);
		outlet(0, "recordsprite");
		outlet(0, new Atom[] { Atom.newAtom("frgb"), Atom.newAtom(FGCOLOR[0]), Atom.newAtom(FGCOLOR[1]), Atom.newAtom(FGCOLOR[2])}); 
		
		outputUpper[0] = Atom.newAtom("linesegment");
		outputLower[0] = Atom.newAtom("linesegment");

		for (int i = 0; i < sb.length; i++) {
			phase = (((double)i / (double)this.grain)) ;
			if (i>0)
				{	prev[0]=curr[0];
					prev[1]=curr[1];
					prev[2]=curr[2];
					prev[3]=curr[3];	}

			curr[0] = Atom.newAtom(phase*this.size[0]);
			curr[2] = curr[0];
			curr[1] = Atom.newAtom(yOffset - sb[i] * zoom * this.size[1]);
			curr[3] = Atom.newAtom(yOffset + sb[i] * zoom * this.size[1]);
			if (i==0)		
				{	prev[0]=Atom.newAtom(0);
					prev[1]=Atom.newAtom(this.size[1] * 0.5);
					prev[2]=prev[0];
					prev[3]=prev[1];	}

			outputUpper[1]=prev[0];
			outputUpper[2]=prev[1];
			outputUpper[3]=curr[0];
			outputUpper[4]=curr[1];

			outputLower[1]=prev[2];
			outputLower[2]=prev[3];
			outputLower[3]=curr[2];
			outputLower[4]=curr[3];

			outlet(0,outputUpper);
			outlet(0,outputLower);

		}
		
		outlet(0, "closesprite", "toto");
		outlet(0, new Atom[] { Atom.newAtom("drawsprite"), Atom.newAtom("toto"), Atom.newAtom(0), Atom.newAtom(0) });
		drawingBG = false;
	}
	
	public void play(double d) {
		if (drawingBG)
			return;
		
		outlet(0, "clear");
		if (d >= 0.) {
			long xOffset = Math.round(this.size[0] * d);

			outlet(0, new Atom[] { Atom.newAtom("frgb"), Atom.newAtom(255), Atom.newAtom(0), Atom.newAtom(0) });
			outlet(0, new Atom[] { Atom.newAtom("pensize"), Atom.newAtom(2), Atom.newAtom(2) });
			outlet(0, new Atom[] { Atom.newAtom("linesegment"), Atom.newAtom(xOffset),Atom.newAtom(0), Atom.newAtom(xOffset), Atom.newAtom(this.size[1]) }); 
		}
	}
}





